Index: binaries/data/mods/public/gui/summary/summary.js
===================================================================
--- binaries/data/mods/public/gui/summary/summary.js	(revision 14702)
+++ binaries/data/mods/public/gui/summary/summary.js	(working copy)
@@ -61,245 +529,296 @@
 	}
 
 	Engine.GetGUIObjectByName("mapName").caption = data.mapSettings.Name + " - " + mapSize;
+	
+	// Panels
+	// Align headers
+	var left = 50;
+	for each (var panel in panels)	// for all panels
+		alignHeaders(panel.headings);
 
-	// Space player boxes
-	var boxSpacing = 32;
-	for (var i = 0; i < panelNames.length; ++i)
+	// TODO set maxPlayers as playerCounters.length
+	var maxPlayers = data.playerStates.length - 1;
+	var maxTeams = 0;
+
+	var teams = [ ];
+	if (data.mapSettings.LockTeams)	// teams ARE locked
 	{
-		for (var j = 0; j < MAX_SLOTS; ++j)
+		// count teams
+		for(var t = 0; t < maxPlayers; ++t)
 		{
-			var box = Engine.GetGUIObjectByName("playerBox"+i+"["+j+"]");
-			var boxSize = box.size;
-			var h = boxSize.bottom - boxSize.top;
-			boxSize.top = j * boxSpacing;
-			boxSize.bottom = j * boxSpacing + h;
-			box.size = boxSize;
+			if (!teams[data.playerStates[t+1].team])
+			{
+				teams[data.playerStates[t+1].team] = 1;
+				continue;
+			}
+			teams[data.playerStates[t+1].team]++;
 		}
+		
+		if (teams.length == maxPlayers)
+			teams = false;	// Each player has his own team. Displaying teams makes no sense.
 	}
-
-	// TODO set maxPlayers as playerCounters.length
-	var maxPlayers = data.playerStates.length - 1;
-
-	// Align headers
-	var left = 50;
-	var width = 100;
-	var playerNameHeadingWidth = 200;
-	// Special cased to make the (Sent / Received) part fit
-	var tributesWidth = 121;
-	Engine.GetGUIObjectByName("playerName0Heading").size = left + " 26 " + (left + playerNameHeadingWidth) + " 100%"; left += playerNameHeadingWidth;
-	Engine.GetGUIObjectByName("economyScoreHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("militaryScoreHeading").size = left +  " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("explorationScoreHeading").size = left +  " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("totalScoreHeading").size = left +  " 16 " + (left + width) + " 100%"; left += width;
+	else				// teams are NOT locked
+		teams = false;
 	
-	left = 50;
-	Engine.GetGUIObjectByName("playerName1Heading").size = left + " 26 " + (left + playerNameHeadingWidth) + " 100%"; left += playerNameHeadingWidth;
-	Engine.GetGUIObjectByName("unitsTrainedHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("unitsLostHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("enemyUnitsKilledHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("buildingsConstructedHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("buildingsLostHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("enemyBuildingsDestroyedHeading").size = left + " 6 " + (left + width) + " 100%"; left += width;
-
-	left = 50;
-	Engine.GetGUIObjectByName("playerName2Heading").size = left + " 26 " + (left + playerNameHeadingWidth) + " 100%"; left += playerNameHeadingWidth;
-	Engine.GetGUIObjectByName("civCentresBuiltHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("enemyCivCentresDestroyedHeading").size = left +  " 6 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("mapExplorationHeading").size = left +  " 6 " + (left + width) + " 100%"; left += width;
-
-	left = 50;
-	Engine.GetGUIObjectByName("playerName3Heading").size = left + " 26 " + (left + playerNameHeadingWidth) + " 100%"; left += playerNameHeadingWidth;
-	Engine.GetGUIObjectByName("resourceHeading").size = left + " 16 " + (left + width * 4) + " 100%";
-	Engine.GetGUIObjectByName("foodGatheredHeading").size = left + " 34 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("woodGatheredHeading").size = left + " 34 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("stoneGatheredHeading").size = left + " 34 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("metalGatheredHeading").size = left + " 34 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("vegetarianRatioHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("treasuresCollectedHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("resourcesTributedHeading").size = left + " 16 " + (left + tributesWidth) + " 100%"; left += tributesWidth;
-
-	left = 50;
-	Engine.GetGUIObjectByName("playerName4Heading").size = left + " 26 " + (left + playerNameHeadingWidth) + " 100%"; left += playerNameHeadingWidth;
-	Engine.GetGUIObjectByName("exchangedFoodHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("exchangedWoodHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("exchangedStoneHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("exchangedMetalHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("barterEfficiencyHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-	Engine.GetGUIObjectByName("tradeIncomeHeading").size = left + " 16 " + (left + width) + " 100%"; left += width;
-
-	// Show counters
-	for (var i = 0; i < MAX_SLOTS; ++i)
+	// Erase teams data if teams are not displayed
+	if (!teams)
 	{
-		if (i < maxPlayers)
+		for(var p = 0; p < maxPlayers; ++p)
+			data.playerStates[p+1].team = -1;
+	}
+	
+	// Count players without team	(or all if teams are not displayed)
+	var withoutTeam = maxPlayers;
+	if (teams)
+	{
+		// count players without team	(or all if teams are not displayed)
+		for (var i = 0; i < teams.length; ++i)
+			withoutTeam -= teams[i];
+		
+		// Display teams boxes
+		var p = 0;
+		for each (var panel in panels)
 		{
-			var playerState = data.playerStates[i+1];
-
-			for (var k = 0; k < panelNames.length; ++k)
+			var yStart = TEAMS_BOX_Y_START + withoutTeam * (PLAYER_BOX_Y_SIZE + PLAYER_BOX_GAP);
+			for (var i = 0; i < teams.length; ++i)
 			{
-				var playerBox = Engine.GetGUIObjectByName("playerBox"+k+"["+i+"]");
-				playerBox.hidden = false;
-
-				var colourString = "colour: "
-					+ Math.floor(playerState.colour.r * 255) + " "
-					+ Math.floor(playerState.colour.g * 255) + " "
-					+ Math.floor(playerState.colour.b * 255);
-				playerBox.sprite = colourString + " 32";
-				var playerColourBox = Engine.GetGUIObjectByName("playerColourBox"+k+"["+i+"]");
-				playerColourBox.sprite = colourString + " 255";
-
-				// Show the multiplayer name, e.g. "Foobar" rather than "Player 1".
-				// TODO: Perhaps show both the multiplayer and map-specific name?
-				var playerName = Engine.GetGUIObjectByName("playerName"+k+"["+i+"]");
-				playerName.caption = data.players[i+1].name;
-
-				Engine.GetGUIObjectByName("civIcon"+k+"["+i+"]").sprite = "stretched:"+civData[playerState.civ].Emblem;
-				Engine.GetGUIObjectByName("civIcon"+k+"["+i+"]").tooltip = civData[playerState.civ].Name;
+				var teamBox = Engine.GetGUIObjectByName("teamBox"+p+"t"+i);
+				teamBox.hidden = false;
+				var teamBoxSize = teamBox.size;
+				teamBoxSize.top = yStart;
+				teamBox.size = teamBoxSize;
+				
+				yStart += 30 + teams[i] * (PLAYER_BOX_Y_SIZE + PLAYER_BOX_GAP) + 32;
+				
+				Engine.GetGUIObjectByName("teamNameHeading"+p+"t"+i).caption = "Team "+(i+1);
+				
+				// Make place to store team scores
+				for each (var counter in panel.counters)
+				{
+					counter.teamsScores[i] = 0;
+					counter.teamsScoresCaption[i] = "0";
+				}
 			}
+			
+			// If there are no players without team, hide "player name" heading
+			if (!withoutTeam)
+				Engine.GetGUIObjectByName("playerName"+p+"Heading").caption = "";	
+			
+			p++;
+		}
+	}
+	
+	if (withoutTeam)
+	{
+		// Show boxes for no teams
+		for (var b = 0; b < PANELS_COUNT; ++b)
+			Engine.GetGUIObjectByName("noTeamsBox"+b).hidden = false;
+	}
 
-			var economyScore = Engine.GetGUIObjectByName("economyScore["+i+"]");
-			var militaryScore = Engine.GetGUIObjectByName("militaryScore["+i+"]");
-			var explorationScore = Engine.GetGUIObjectByName("explorationScore["+i+"]");
-			var totalScore = Engine.GetGUIObjectByName("totalScore["+i+"]");
+	var playerBoxesCounts = [ ];
+	for (var i = 0; i < maxPlayers; ++i)
+	{
+		var tn = "";
+		var playerState = data.playerStates[i+1];
+		
+		if (!playerBoxesCounts[playerState.team+1])
+			playerBoxesCounts[playerState.team+1] = 1;
+		else
+			playerBoxesCounts[playerState.team+1] += 1;
 
-			var unitsTrained = Engine.GetGUIObjectByName("unitsTrained["+i+"]");
-			var unitsLost = Engine.GetGUIObjectByName("unitsLost["+i+"]");
-			var enemyUnitsKilled = Engine.GetGUIObjectByName("enemyUnitsKilled["+i+"]");
-			var buildingsConstructed = Engine.GetGUIObjectByName("buildingsConstructed["+i+"]");
-			var buildingsLost = Engine.GetGUIObjectByName("buildingsLost["+i+"]");
-			var enemyBuildingsDestroyed = Engine.GetGUIObjectByName("enemyBuildingsDestroyed["+i+"]");
+		if (playerState.team != -1)
+			tn = "t"+playerState.team+"p";
 
-			var civCentresBuilt = Engine.GetGUIObjectByName("civCentresBuilt["+i+"]");
-			var enemyCivCentresDestroyed = Engine.GetGUIObjectByName("enemyCivCentresDestroyed["+i+"]");
-			var mapExploration = Engine.GetGUIObjectByName("mapExploration["+i+"]");
-
-			var foodGathered = Engine.GetGUIObjectByName("foodGathered["+i+"]");
-			var woodGathered = Engine.GetGUIObjectByName("woodGathered["+i+"]");
-			var stoneGathered = Engine.GetGUIObjectByName("stoneGathered["+i+"]");
-			var metalGathered = Engine.GetGUIObjectByName("metalGathered["+i+"]");
-			var vegetarianRatio = Engine.GetGUIObjectByName("vegetarianRatio["+i+"]");
-			var treasuresCollected = Engine.GetGUIObjectByName("treasuresCollected["+i+"]");
-			var resourcesTributed = Engine.GetGUIObjectByName("resourcesTributed["+i+"]");
-
-			var exchangedFood = Engine.GetGUIObjectByName("exchangedFood["+i+"]");
-			var exchangedWood = Engine.GetGUIObjectByName("exchangedWood["+i+"]");
-			var exchangedStone = Engine.GetGUIObjectByName("exchangedStone["+i+"]");
-			var exchangedMetal = Engine.GetGUIObjectByName("exchangedMetal["+i+"]");
-			var barterEfficiency = Engine.GetGUIObjectByName("barterEfficiency["+i+"]");
-			var tradeIncome = Engine.GetGUIObjectByName("tradeIncome["+i+"]");
-
-			// align counters
-
-			left = 240;
-			width = 100;
-			economyScore.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			militaryScore.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			explorationScore.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			totalScore.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			var size = Engine.GetGUIObjectByName("playerBox0["+i+"]").size;
-			size.right = left + 10;
-			Engine.GetGUIObjectByName("playerBox0["+i+"]").size = size;
+		var j = 0;
+		for each (var panel in panels)
+		{
+			var playerIdentityString = tn+"["+(playerBoxesCounts[playerState.team+1]-1)+"]";
+			// Display boxes for players
+			var playerBox = Engine.GetGUIObjectByName("playerBox"+j+playerIdentityString); 
+			playerBox.hidden = false;
 			
-			left = 240;
-			unitsTrained.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			unitsLost.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			enemyUnitsKilled.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			buildingsConstructed.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			buildingsLost.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			enemyBuildingsDestroyed.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			size = Engine.GetGUIObjectByName("playerBox1["+i+"]").size;
-			size.right = left + 10;
-			Engine.GetGUIObjectByName("playerBox1["+i+"]").size = size;
+			var boxSize = playerBox.size;
+			boxSize.top += (playerBoxesCounts[playerState.team+1] - 1) * (PLAYER_BOX_Y_SIZE + PLAYER_BOX_GAP);
+			boxSize.bottom = boxSize.top + PLAYER_BOX_Y_SIZE;
+			playerBox.size = boxSize;
+			
+			var colourString = "colour: "
+				+ Math.floor(playerState.colour.r * 255) + " "
+				+ Math.floor(playerState.colour.g * 255) + " "
+				+ Math.floor(playerState.colour.b * 255);
+			
+			playerBox.sprite = colourString + PLAYER_BOX_ALPHA;
+			
+			var playerColourBox = Engine.GetGUIObjectByName("playerColourBox"+j+playerIdentityString);
+			playerColourBox.sprite = colourString + PLAYER_COLOUR_BOX_ALPHA;
+			
+			// Show the multiplayer name, e.g. "Foobar" rather than "Player 1".
+			// TODO: Perhaps show both the multiplayer and map-specific name?
+			var playerName = Engine.GetGUIObjectByName("playerName"+j+playerIdentityString);
+			playerName.caption = data.players[i+1].name;
 
-			left = 240;
-			civCentresBuilt.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			enemyCivCentresDestroyed.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			mapExploration.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			size = Engine.GetGUIObjectByName("playerBox2["+i+"]").size;
-			size.right = left + 10;
-			Engine.GetGUIObjectByName("playerBox2["+i+"]").size = size;
-
-			left = 240;
-			foodGathered.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			woodGathered.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			stoneGathered.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			metalGathered.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			vegetarianRatio.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			treasuresCollected.size	= left + " 2 " + (left + width) + " 100%"; left += width;
-			resourcesTributed.size = left + " 2 " + (left + tributesWidth) + " 100%"; left += tributesWidth;
-			size = Engine.GetGUIObjectByName("playerBox3["+i+"]").size;
-			size.right = left + 10;
-			Engine.GetGUIObjectByName("playerBox3["+i+"]").size = size;
-
-			left = 240;
-			exchangedFood.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			exchangedWood.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			exchangedStone.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			exchangedMetal.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			barterEfficiency.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			tradeIncome.size = left + " 2 " + (left + width) + " 100%"; left += width;
-			size = Engine.GetGUIObjectByName("playerBox4["+i+"]").size;
-			size.right = left + 10;
-			Engine.GetGUIObjectByName("playerBox4["+i+"]").size = size;
-
-			// display counters
-			economyScore.caption = Math.round((playerState.statistics.resourcesGathered.food + playerState.statistics.resourcesGathered.wood + 
-				playerState.statistics.resourcesGathered.stone + playerState.statistics.resourcesGathered.metal) / 10);
-			militaryScore.caption = Math.round((playerState.statistics.enemyUnitsKilledValue + playerState.statistics.enemyBuildingsDestroyedValue) / 10);
-			explorationScore.caption = playerState.statistics.percentMapExplored * 10;
-			totalScore.caption = Number(economyScore.caption) + Number(militaryScore.caption) + Number(explorationScore.caption);
+			var civIcon = Engine.GetGUIObjectByName("civIcon"+j+playerIdentityString);
+			civIcon.sprite = "stretched:"+civData[playerState.civ].Emblem;
+			civIcon.tooltip = civData[playerState.civ].Name;
 			
-			unitsTrained.caption = playerState.statistics.unitsTrained;
-			unitsLost.caption = playerState.statistics.unitsLost;
-			enemyUnitsKilled.caption = playerState.statistics.enemyUnitsKilled;
-			buildingsConstructed.caption = playerState.statistics.buildingsConstructed;
-			buildingsLost.caption = playerState.statistics.buildingsLost;
-			enemyBuildingsDestroyed.caption = playerState.statistics.enemyBuildingsDestroyed;
-
-			civCentresBuilt.caption = playerState.statistics.civCentresBuilt;
-			enemyCivCentresDestroyed.caption = playerState.statistics.enemyCivCentresDestroyed;
-			mapExploration.caption = playerState.statistics.percentMapExplored + "%";
-
-			const SOLD_COLOR = '[color="201 255 200"]';
-			const BOUGHT_COLOR = '[color="255 213 213"]';
-			foodGathered.caption = SOLD_COLOR + playerState.statistics.resourcesGathered.food + "[/color] / " +
-				BOUGHT_COLOR + (playerState.statistics.resourcesUsed.food - playerState.statistics.resourcesSold.food) + "[/color]";
-			woodGathered.caption = SOLD_COLOR + playerState.statistics.resourcesGathered.wood + "[/color] / " +
-				BOUGHT_COLOR + (playerState.statistics.resourcesUsed.wood - playerState.statistics.resourcesSold.wood) + "[/color]";
-			stoneGathered.caption = SOLD_COLOR + playerState.statistics.resourcesGathered.stone + "[/color] / " +
-				BOUGHT_COLOR + (playerState.statistics.resourcesUsed.stone - playerState.statistics.resourcesSold.stone) + "[/color]";
-			metalGathered.caption = SOLD_COLOR + playerState.statistics.resourcesGathered.metal + "[/color] / " +
-				BOUGHT_COLOR + (playerState.statistics.resourcesUsed.metal - playerState.statistics.resourcesSold.metal) + "[/color]";
-			vegetarianRatio.caption = Math.floor(playerState.statistics.resourcesGathered.food > 0 ?
-				(playerState.statistics.resourcesGathered.vegetarianFood / playerState.statistics.resourcesGathered.food) * 100 : 0) + "%";
-			treasuresCollected.caption = playerState.statistics.treasuresCollected;
-			resourcesTributed.caption = SOLD_COLOR + playerState.statistics.tributesSent + "[/color] / " +
-				BOUGHT_COLOR + playerState.statistics.tributesReceived + "[/color]";
-
-			exchangedFood.caption = SOLD_COLOR + '+' + playerState.statistics.resourcesBought.food
-				+ '[/color] ' + BOUGHT_COLOR + '-' + playerState.statistics.resourcesSold.food + '[/color]';
-			exchangedWood.caption = SOLD_COLOR + '+' + playerState.statistics.resourcesBought.wood
-				+ '[/color] ' + BOUGHT_COLOR + '-' + playerState.statistics.resourcesSold.wood + '[/color]';
-			exchangedStone.caption = SOLD_COLOR + '+' + playerState.statistics.resourcesBought.stone
-				+ '[/color] ' + BOUGHT_COLOR + '-' + playerState.statistics.resourcesSold.stone + '[/color]';
-			exchangedMetal.caption = SOLD_COLOR + '+' + playerState.statistics.resourcesBought.metal
-				+ '[/color] ' + BOUGHT_COLOR + '-' + playerState.statistics.resourcesSold.metal + '[/color]';
-			var totalBought = 0;
-			for each (var boughtAmount in playerState.statistics.resourcesBought)
-				totalBought += boughtAmount;
-			var totalSold = 0;
-			for each (var soldAmount in playerState.statistics.resourcesSold)
-				totalSold += soldAmount;
-			barterEfficiency.caption = Math.floor(totalSold > 0 ? (totalBought / totalSold) * 100 : 0) + "%";
-			tradeIncome.caption = playerState.statistics.tradeIncome;
+			// Get counters
+			for (var c in panel.counters)
+			{
+				panel.counters[c].objects[i] = Engine.GetGUIObjectByName(c+playerIdentityString);
+			}
+			
+			// Align counters
+			var right = alignCounters(panel.counters, i);
+			boxSize.right = right;
+			playerBox.size = boxSize;
+			
+			j++;
 		}
-		else
+		
+		// Assign counters
+		// score panel
+		panels.score.counters.economyScore.objects[i].caption = captionEconomyScore();
+		panels.score.counters.militaryScore.objects[i].caption = Math.round((playerState.statistics.enemyUnitsKilledValue +
+			playerState.statistics.enemyBuildingsDestroyedValue) / 10);
+		panels.score.counters.explorationScore.objects[i].caption = playerState.statistics.percentMapExplored * 10;
+		panels.score.counters.totalScore.objects[i].caption = (+panels.score.counters.economyScore.objects[i].caption) +
+			(+panels.score.counters.militaryScore.objects[i].caption) +
+			(+panels.score.counters.explorationScore.objects[i].caption);
+		// buildings panel
+		var t = 0;
+		for each (var counter in panels.buildings.counters)
 		{
-			// hide player boxes
-			for (var k = 0; k < panelNames.length; ++k)
+			captionBuildings(counter.objects[i], BUILDINGS_TYPES[t]);
+			t++;
+		}
+		// units panel
+		t = 0;
+		for each (var counter in panels.units.counters)
+		{
+			captionUnits(counter.objects[i], UNITS_TYPES[t]);
+			t++;
+		}
+		// resources panel
+		t = 0;
+		for each (var counter in panels.resources.counters)
+		{
+			if (t >= 4)	// only 4 first counters
+				break;
+			
+			captionResourcesGathered(counter.objects[i], RESOURCES_TYPES[t]);
+			t++;
+		}
+		panels.resources.counters.totalGathered.objects[i].caption = captionTotalResourcesGathered();
+		panels.resources.counters.treasuresCollected.objects[i].caption = playerState.statistics.treasuresCollected;
+		panels.resources.counters.resourcesTributed.objects[i].caption = captionResourcesTributed();
+		// market panel
+		t = 0;
+		for (var c in panels.market.counters)
+		{
+			if (t >= 4)	// only 4 first counters
+				break;
+			
+			captionResourcesExchanged(panels.market.counters[c].objects[i], RESOURCES_TYPES[t]);
+			t++;
+		}
+		panels.market.counters.barterEfficiency.objects[i].caption = captionBarterEfficiency();
+		panels.market.counters.tradeIncome.objects[i].caption = playerState.statistics.tradeIncome;
+		// miscelanous panel
+		panels.miscelanous.counters.vegetarianRatio.objects[i].caption = captionVegetarianRatio();
+		panels.miscelanous.counters.feminisation.objects[i].caption = captionFeminisation();
+		panels.miscelanous.counters.killDeathRatio.objects[i].caption = captionKillDeathRatio();
+		panels.miscelanous.counters.mapExploration.objects[i].caption = playerState.statistics.percentMapExplored + "%";
+		
+		if (!teams)
+			continue;
+		
+		if (playerState.team == -1)
+			continue;
+		
+		// Evaluate team total score
+		// score panel
+		for (var c in panels.score.counters)
+		{
+			panels.score.counters[c].teamsScores[playerState.team] += (+panels.score.counters[c].objects[i].caption);
+			panels.score.counters[c].teamsScoresCaption[playerState.team] = panels.score.counters[c].teamsScores[playerState.team];
+		}
+		// buildings panel
+		var t = 0;
+		for each (var counter in panels.buildings.counters)
+		{
+			sumTeamBuildings(counter, BUILDINGS_TYPES[t]);
+			t++;
+		}
+		// units panel
+		t = 0;
+		for each (var counter in panels.units.counters)
+		{
+			sumTeamUnits(counter, UNITS_TYPES[t]);
+			t++;
+		}
+		// resources panel
+		t = 0;
+		for each (var counter in panels.resources.counters)
+		{
+			if (t >= 4)	// only 4 first counters
+				break;
+			
+			sumResourcesGathered(counter, RESOURCES_TYPES[t]);
+			t++;
+		}
+		sumTotalResourcesGathered();
+		panels.resources.counters.treasuresCollected.teamsScores[playerState.team] += playerState.statistics.treasuresCollected;
+		panels.resources.counters.treasuresCollected.teamsScoresCaption[playerState.team] = panels.resources.counters.treasuresCollected.teamsScores[playerState.team];
+		sumResourcesTributed();
+		// market panel
+		t = 0;
+		for (var c in panels.market.counters)
+		{
+			if (t >= 4)	// only 4 first counters
+				break;
+			
+			sumResourcesExchanged(panels.market.counters[c], RESOURCES_TYPES[t]);
+			t++;
+		}
+		sumBarterEfficiency();
+		panels.market.counters.tradeIncome.teamsScores[playerState.team] += playerState.statistics.tradeIncome;
+		panels.market.counters.tradeIncome.teamsScoresCaption[playerState.team] = panels.market.counters.tradeIncome.teamsScores[playerState.team];
+		// miscelanous panel
+		sumVegetarianRatio();
+		sumFeminisation();
+		sumKillDeathRatio();
+		// TODO: probably change from simple sum to union from range manager
+		panels.miscelanous.counters.mapExploration.teamsScores[playerState.team] += playerState.statistics.percentMapExplored;
+		panels.miscelanous.counters.mapExploration.teamsScoresCaption[playerState.team] = panels.miscelanous.counters.mapExploration.teamsScores[playerState.team] + "%";
+	}
+	
+	if (!teams)
+	{
+		selectPanel(0);
+		return;
+	}
+	
+	// Display teams totals counters
+	for (var i = 0; i < teams.length; ++i)
+	{
+		var pn = 0;
+		for each (var panel in panels)
+		{
+			var teamHeading = Engine.GetGUIObjectByName("teamHeading"+pn+"t"+i);
+			var yStart = 30 + teams[i] * (PLAYER_BOX_Y_SIZE + PLAYER_BOX_GAP) + 2;
+			teamHeading.size = "50 "+yStart+" 100% "+(yStart+20);
+			teamHeading.caption = "Team total";
+			
+			var left = 250;
+			for (var c in panel.counters)
 			{
-				var playerBox = Engine.GetGUIObjectByName("playerBox"+k+"["+i+"]");
-				playerBox.hidden = true;
+				var counter = Engine.GetGUIObjectByName(c+"t"+i);
+				counter.size = left + " " + yStart + " " + (left + panel.counters[c].width) + " " + (yStart+20);
+				counter.caption = panel.counters[c].teamsScoresCaption[i];
+				
+				left += panel.counters[c].width;
 			}
+			pn++;
 		}
 	}
 
Index: binaries/data/mods/public/simulation/components/Foundation.js
===================================================================
--- binaries/data/mods/public/simulation/components/Foundation.js	(revision 14702)
+++ binaries/data/mods/public/simulation/components/Foundation.js	(working copy)
@@ -314,11 +314,7 @@
 		// ----------------------------------------------------------------------
 		
 		var cmpPlayerStatisticsTracker = QueryOwnerInterface(this.entity, IID_StatisticsTracker);
-		cmpPlayerStatisticsTracker.IncreaseConstructedBuildingsCounter();
-
-		var cmpIdentity = Engine.QueryInterface(building, IID_Identity);
-		if (cmpIdentity.GetClassesList().indexOf("CivCentre") != -1)
-			cmpPlayerStatisticsTracker.IncreaseBuiltCivCentresCounter();
+		cmpPlayerStatisticsTracker.IncreaseConstructedBuildingsCounter(building);
 		
 		var cmpHealth = Engine.QueryInterface(this.entity, IID_Health);
 		var cmpBuildingHealth = Engine.QueryInterface(building, IID_Health);
Index: binaries/data/mods/public/simulation/components/ProductionQueue.js
===================================================================
--- binaries/data/mods/public/simulation/components/ProductionQueue.js	(revision 14702)
+++ binaries/data/mods/public/simulation/components/ProductionQueue.js	(working copy)
@@ -571,7 +571,7 @@
 		}
 
 		var cmpPlayerStatisticsTracker = QueryOwnerInterface(this.entity, IID_StatisticsTracker);
-		cmpPlayerStatisticsTracker.IncreaseTrainedUnitsCounter();
+		cmpPlayerStatisticsTracker.IncreaseTrainedUnitsCounter(ent);
 
 		// Play a sound, but only for the first in the batch (to avoid nasty phasing effects)
 		if (createdEnts.length == 0)
